import es, playerlib, popuplib, cfglib, services

config = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + '/cfg/respawnmenu.cfg')
config.text("**************************")
config.text("       Respawn Menu       ")
config.text("**************************")
respawnmenu_command   = config.cvar("respawnmenu_command",   '!respawnmenu', "What admins type to bring menu up")
respawnmenu_announce   = config.cvar("respawnmenu_announce",   1, "Announces who you respawned")


config.write()

# ======================#
#         PUBLIC
# ======================#
info = es.AddonInfo()
info.name     = "Respawn Menu"
info.version  = "1.4"
info.url      = "None"
info.basename = "sic_respawnmenu"
info.author   = "sicman_adrian"
es.ServerVar(info.basename, info.version, info.name).makepublic()

def load():
    setup_auth()
    config.execute()
    if not es.exists('saycommand', respawnmenu_command ):
        es.regsaycmd(respawnmenu_command , 'respawnmenu/CheckAuth')

def unload():
    if es.exists('saycommand', respawnmenu_command):
        es.unregsaycmd(respawnmenu_command)

class respawnmenu:
    def __init__(self, userid):
        self.userid = userid
        sic_respawnmenu = popuplib.easymenu('player_list', '_popup_choice', self.playerSelected)
        sic_respawnmenu.settitle('Respawn Menu')
        playerlist = playerlib.getPlayerList('#all')
        for player in playerlist:
            t_userid = int(player)
            t_name = player.get('name')
            sic_respawnmenu.addoption(t_userid, t_name)
        sic_respawnmenu.addoption("#t", "Terroristakat")
        sic_respawnmenu.addoption("#c", "Ct ket")
        sic_respawnmenu.addoption("#d", "az oszes Halot embert")
        sic_respawnmenu.send(userid)

    def playerSelected(self, caller, target, sic_respawnmenu):
        if target not in ['#c','#t','#d']:
            self.Respawn(target)
            if int(respawnmenu_announce):
                es.msg('#multi', '#green[Respawn Admin] #lightgreen %s #defaultrespawn #lightgreen%s' % (es.getplayername(caller), es.getplayername(target)))
        elif target == '#c':
              for userid in playerlib.getUseridList('#c'):
                   self.Respawn(userid)
              if int(respawnmenu_announce):
                  es.msg('#multi','#green[Respawn Admin] #lightgreen %s #defaultrespawn Ct ket' % es.getplayername(caller))
        elif target == '#t':
              for userid in playerlib.getUseridList('#t'):
                    self.Respawn(userid)
              if int(respawnmenu_announce):
                  es.msg('#multi','#green[Respawn Admin] #lightgreen %s #defaultrespawn Terroristakat' % es.getplayername(caller))
        elif target == '#d':
              for userid in playerlib.getUseridList('#dead'):
                   self.Respawn(userid)
              if int(respawnmenu_announce):
                  es.msg('#multi','#green[Respawn Admin] #lightgreen %s #defualtrespawn az oszes Halot embert' % es.getplayername(caller))
        respawnmenu(caller)
    def Respawn(self, userid):
        es.setplayerprop(userid, "CCSPlayer.m_iPlayerState", 0)
        es.setplayerprop(userid, "CCSPlayer.baseclass.m_lifeState", 512)
        es.spawnplayer(userid)

def CheckAuth():
    userid = str(es.getcmduserid())
    if isAuthed(userid):
        respawnmenu(userid)
    else:
        es.tell(userid, '#multi','#greenYou are not authorized to run this command')

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('respawnmenu_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'respawnmenu_admin')
    else:
        isAuthed = lambda x: False